unit main;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, ComCtrls, ExtCtrls,
	DirectShow9;

const
	//Cxg󂯎邽߂̃j[NȃbZ[Wԍ
	WM_GRAPH_NOTIFY = (WM_APP +1);

type
	TForm1 = class(TForm)
		ComboBox1:      TComboBox;
		Button_Open:    TButton;
		Button_Delete:  TButton;
		Button_Clear:   TButton;
		Button_Play:    TButton;
		Button_Pause:   TButton;
		Button_Stop:    TButton;
		TrackBar1:      TTrackBar;
		Label_Time:     TLabel;
		Label_Size:     TLabel;
		CheckBox_Event: TCheckBox;
		Timer1:         TTimer;
		OpenDialog1:    TOpenDialog;
		procedure FormCreate (Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure Button_OpenClick  (Sender: TObject);
		procedure Button_DeleteClick(Sender: TObject);
		procedure Button_ClearClick (Sender: TObject);
		procedure Button_PlayClick  (Sender: TObject);
		procedure Button_PauseClick (Sender: TObject);
		procedure Button_StopClick  (Sender: TObject);
		procedure ComboBox1Select   (Sender: TObject);
		procedure TrackBar1Change   (Sender: TObject);
		procedure Timer1Timer       (Sender: TObject);
	private
		{ Private 錾 }
		F_GraphBuilder  : IGraphBuilder;
		F_MediaEventEx  : IMediaEventEx;
		F_MediaPosition : IMediaPosition;
		F_fDuration     : TRefTime;

		//Cxgʒm̂߂̃bZ[Wԍ󂯎悤ɂ
		procedure WMGraphNotify(var Msg: TMessage); message WM_GRAPH_NOTIFY;
		procedure F_Close;
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation
uses
	ActiveX,
	debug_msg; //fobOo͗p

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
	Label_Size.Caption := '';
	Label_Time.Caption := '';

	//Ot쐬
	CoCreateInstance(
		CLSID_FilterGraph,
		nil,
		CLSCTX_INPROC_SERVER,
		IID_IGraphBuilder,
		F_GraphBuilder
	);

	//CxgʒmEBhEZbgB
	F_GraphBuilder.QueryInterface(IMediaEventEx, F_MediaEventEx);
	F_MediaEventEx.SetNotifyWindow(Self.Handle, WM_GRAPH_NOTIFY, 0);

	//Ԏ擾̂
	F_GraphBuilder.QueryInterface(IMediaPosition, F_MediaPosition);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
	F_Close;
	F_MediaPosition := nil;
	F_MediaEventEx  := nil;
	F_GraphBuilder  := nil;
end;

procedure TForm1.Button_PlayClick(Sender: TObject);
//ĐJn
var
	l_MediaControl : IMediaControl;
begin
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Run;
		l_MediaControl := nil;

		Timer1.Enabled := True;
	end;
end;

procedure TForm1.Button_PauseClick(Sender: TObject);
//ꎞ~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Pause;
		l_MediaControl := nil;
	end;
end;

procedure TForm1.Button_StopClick(Sender: TObject);
//~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Stop;

		//~łPauseƕςȂ
		//擪ɖ߂ɂIMediaPositiong
		F_MediaPosition.put_CurrentPosition(0);

		//ړł݈͌ʒũt[`悳ȂB
		//݈ʒũt[`悳邽߂Pause邢StopWhenReadyĂԁB
		l_MediaControl.StopWhenReady;
		l_MediaControl := nil;

		Timer1.Tag := 1;
		TrackBar1.Position := 0;
		Timer1.Tag := 0;
	end;
end;

//--- V[No[ ---
procedure TForm1.Timer1Timer(Sender: TObject);
//݈ʒu\
	function FloatToTime(fTime : TRefTime) : String;
	var
		li_Time, li_Hour, li_Min, li_Sec : Integer;
	begin
		li_Time := Trunc(fTime);
		li_Hour := li_Time div 60 div 60;
		li_Min  := li_Time div 60 mod 60;
		li_Sec  := li_Time mod 60;
		Result  := Format('%d:%.2d:%.2d', [li_Hour, li_Min, li_Sec]);
	end;
	function IsDragThumb: Boolean;
	//gbNo[̃XC_[GĂ邩B
	//ۂ̓gbNo[}EXLv`Ă邩B
	begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			Result := False;
			Exit;
		end;
		Result := (GetCapture = TrackBar1.Handle);
	end;
var
	lf_Pos : TRefTime;
begin
	if (Assigned(F_GraphBuilder)) then begin
		Timer1.Tag := 1;

		F_MediaPosition.get_CurrentPosition(lf_Pos);
		Label_Time.Caption := Format('%s/%s', [FloatToTime(lf_Pos), FloatToTime(F_fDuration)]);

		if not(IsDragThumb) then begin
			//gbNo[̃XC_[GĂȂXC_[݈ʒuɈړB
			TrackBar1.Position := Trunc(lf_Pos);
		end;

		Timer1.Tag := 0;
	end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
//gbNo[ړ
var
	l_MediaPosition : IMediaPosition;
begin
	if (Timer1.Tag <> 0) then begin
		Exit;
	end;

	if (Assigned(F_GraphBuilder)) then begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			F_GraphBuilder.QueryInterface(IMediaPosition, l_MediaPosition);
			l_MediaPosition.put_CurrentPosition(TrackBar1.Position);
			l_MediaPosition := nil;
		end;
	end;
end;
//------------------


procedure TForm1.WMGraphNotify(var Msg: TMessage);
//Cxg
var
	li_EventCode   : Longint;
	li_Param1      : Longint;
	li_Param2      : Longint;
begin
	if (F_MediaEventEx = nil) then begin
Exit;
	end;

	// CxgSĎ擾
	while (Succeeded(F_MediaEventEx.GetEvent(li_EventCode, li_Param1, li_Param2, 0))) do begin
		if (CheckBox_Event.Checked) then begin
			debug_msg.ShowEvent(li_EventCode, li_Param1, li_Param2);
		end;

		case (li_EventCode) of
			EC_COMPLETE
			:begin
				//ĐIɗ
				//AĐ
				if (ComboBox1.Items.Count = 0) then begin
					F_Close;
				end else begin
					if (ComboBox1.ItemIndex < ComboBox1.Items.Count -1) then begin
						ComboBox1.ItemIndex := ComboBox1.ItemIndex +1;
					end else begin
						ComboBox1.ItemIndex := 0;
					end;
					ComboBox1Select(nil);
				end;
			end;
		end;
		F_MediaEventEx.FreeEventParams(li_EventCode, li_Param1, li_Param2);
	end;
end;

procedure TForm1.F_Close;
var
	l_MediaControl : IMediaControl;
	l_EnumFilters  : IEnumFilters;
	l_BaseFilter   : IBaseFilter;
begin
	Timer1.Enabled     := False;
	Label_Size.Caption := '';
	Label_Time.Caption := '';

	if (F_GraphBuilder <> nil) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Stop;
		l_MediaControl := nil;

		//Sotpł̓tB^͂܂ڑꂽ܂܂Ȃ̂ŃtB^񋓂č폜B
		//http://msdn.microsoft.com/ja-jp/library/cc973418.aspx
		F_GraphBuilder.EnumFilters(l_EnumFilters);
		while (l_EnumFilters.Next(1, l_BaseFilter, nil) = S_OK) do begin
			F_GraphBuilder.RemoveFilter(l_BaseFilter);
			l_BaseFilter := nil;
			l_EnumFilters.Reset;
		end;
		l_EnumFilters := nil;
	end;
end;

procedure TForm1.Button_OpenClick(Sender: TObject);
//J
var
	li_Count : Integer;
begin
	if (OpenDialog1.Execute) then begin
		li_Count := ComboBox1.Items.Count;
		ComboBox1.Items.AddStrings(OpenDialog1.Files);
		ComboBox1.ItemIndex := li_Count;
		ComboBox1Select(nil); //ĐJn
	end;
end;

procedure TForm1.Button_DeleteClick(Sender: TObject);
//XgĐ̃t@C폜
var
	li_Index : Integer;
begin
	li_Index := ComboBox1.ItemIndex;
	F_Close;
	ComboBox1.Items.Delete(li_Index);
	ComboBox1.ItemIndex := li_Index;
	ComboBox1Select(nil);
end;

procedure TForm1.Button_ClearClick(Sender: TObject);
//XgNA
begin
	ComboBox1.Items.Clear;
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
//t@CIĐ
var
	ls_FileName  : String;
	l_BasicVideo : IBasicVideo;
	li_Width     : Integer;
	li_Height    : Integer;
begin
	F_Close;

	if (ComboBox1.Items.Count = 0) then begin
		Exit;
	end;

	if (ComboBox1.ItemIndex < 0) then begin
		ComboBox1.ItemIndex := 0;
	end;
	ls_FileName := ComboBox1.Items[ComboBox1.ItemIndex];

	//ǂݍ
	if not(Succeeded(F_GraphBuilder.RenderFile(POLESTR(WideString(ls_FileName)), nil))) then begin
		ShowMessage(ls_FileName + #13'͊J܂');
		ComboBox1.Items.Delete(ComboBox1.ItemIndex);
		ComboBox1.Text := '';
		Exit;
	end;

	//^Cgo[Ƀt@C\
	Caption := ExtractFileName(ls_FileName);

	//rfĨTCY擾
	F_GraphBuilder.QueryInterface(IBasicVideo, l_BasicVideo);
	//li_Widthli_Height͕̏K{B
	li_Width  := 0;
	li_Height := 0;
	l_BasicVideo.get_VideoWidth (li_Width);
	l_BasicVideo.get_VideoHeight(li_Height);
	l_BasicVideo := nil;
	if (li_Width > 0) and (li_Height > 0) then begin
		Label_Size.Caption := Format('%d~%d', [li_Width, li_Height]);
	end else begin
		Label_Size.Caption := '';
	end;

	//擾
	F_fDuration := 0;
	F_MediaPosition.get_Duration(F_fDuration); //̌CurrentPositionςĂ܂Ƃ
	TrackBar1.Max := Trunc(F_fDuration);

	//擾CurrentPositionIɈړĂ܂Ƃ̂œɖ߂
	//F_MediaPosition.put_CurrentPosition(0);
	//Button_StopClick̒łĂ
	//ĐJn
	Button_StopClick(nil);
	Button_PlayClick(nil);
end;


end.
